<template>
  <q-page padding class="height-0">
    <q-scroll-area v-if="!loading" class="full-height" :thumb-style="{right: '0', borderRadius: '4px', background: '#d12', opacity: .6, width: '10px'}">
      <q-card flat>
        <q-card-actions vertical>
          <q-btn v-if="canUpload" @click="startUpload" color="primary" size="lg" class="full-width"
            :loading="uploading" :percentage="currentUploadStats().progress"
          >
            Start uploading
            <br/>
            {{currentUploadStats().files}} files | {{humanStorageSize(currentUploadStats().total)}}
            <div slot="loading">
              <q-spinner-gears class="on-left" />
              Upload {{currentUploadStats().files}} files: {{Math.ceil(currentUploadStats().uploaded * 100 / currentUploadStats().total)}}% Loading
            </div>
          </q-btn>
          <q-btn v-if="uploading" @click="stopUpload" color="negative" flat class="full-width">
            Stop upload
          </q-btn>
        </q-card-actions>
      </q-card>
      <div class="row items-stretch gutter-sm">
        <div class="col-12 col-lg-6" v-for="meta in metas" :key="meta.id">
          <q-card flat>
            <q-card-title class="q-px-none">
              Upload Meta files for {{meta.name}}
            </q-card-title>
            <div :class="{
              'no-shadow': !files[meta.id].length,
              'bg-white shadow-1': files[meta.id].length > 0,
            }">
              <q-list :separator="uploading" no-border class="no-padding q-mx-sm">
                <q-list-header v-if="uploading">
                  Upload {{currentUploadStats(files[meta.id]).files}} files
                  <template v-if="currentUploadStats(files[meta.id]).total > 0">
                    : {{Math.ceil(currentUploadStats(files[meta.id]).uploaded * 100 / currentUploadStats(files[meta.id]).total)}}% Loading
                  </template>
                </q-list-header>
                <q-item v-for="file in files[meta.id]" :key="file.__fileId">
                  <q-item-main>
                    <q-item-tile label class="text-truncate" :title="file.name">
                      <small>{{file.name}}</small>
                    </q-item-tile>
                    <q-item-tile sublabel v-if="!uploading">
                      <small v-if="file.__failed && file.__checksum && !file.__doneUploading">{{humanStorageSize(file.__uploaded)}} / </small>
                      <small>{{file.__size}}</small>
                    </q-item-tile>
                    <q-item-tile sublabel color="negative" v-if="file.__failed && file.__failedStatus">
                      {{file.__failedStatus}}
                    </q-item-tile>
                    <q-item-tile v-if="uploading" class="q-my-sm">
                      <q-progress animate
                        :color="file.__failed ? 'negative' : (file.__doneUploading ? 'positive' : 'warning')"
                        :percentage="file.__checksum ? file.__progress : file.__progress_checksum"
                      ></q-progress>
                    </q-item-tile>
                  </q-item-main>
                  <q-item-side right v-if="uploading && file.__failed" stamp="upload failed" color="negative" />
                  <q-item-side right v-if="!file.__failed" :stamp="file.__size" />
                  <q-item-side right v-if="file.__doneUploading && !file.__failed" icon="check" color="positive" />
                  <q-item-side right v-else icon="clear" class="cursor-pointer" @click.native="fileRemove(file, meta.id)" />
                </q-item>
                <q-item v-if="filesUploaded(meta.id)" class="bg-orange text-dark">
                  <q-item-main label="Thanks for the upload. Our employee checks your files and send a feedback by e-mail." />
                </q-item>
              </q-list>
              <q-card-separator v-if="fileCanAdd(meta.id) && files[meta.id].length > 0" class="q-mx-sm" />
              <q-card-actions v-if="fileCanAdd(meta.id)"
                class="relative-position justify-center q-pa-lg"
                :style="!files[meta.id].length ? 'border: 1px dashed #303030;' : ''"
              >
                <div class="q-pa-lg" v-if="!files[meta.id].length">
                  <img src="~assets/metadata_file_types.png" alt="" style="max-width: 100%; height: auto;" />
                </div>
                <div class="row col-12 justify-center">
                  <q-btn size="lg" color="primary" @click="filePick(meta.id)">
                    Select your files to get started
                  </q-btn>
                </div>
                <div class="q-pt-lg">... or simply drop your Documents here.</div>
                <input type="file" :ref="`file_${ meta.id }`"
                  class="q-uploader-input absolute-full cursor-pointer"
                  :multiple="multiple"
                  @change="fileAdd($event, meta.id)"
                />
              </q-card-actions>
            </div>
          </q-card>
        </div>
      </div>
    </q-scroll-area>
    <q-inner-loading :visible="loading" />
  </q-page>
</template>

<script>
  import { format } from 'quasar';
  import asmCrypto from 'asmcrypto.js';
  import { CancelToken, isCancel } from 'axios';
  import { stringify } from 'qs';
  import { getRejectionMessage, showRejectionMessage } from '../../utils';

  const { humanStorageSize } = format;
  const chunkSize = 5 * 1024 * 1024;
  const chunkMaxCount = 2;
  const reRange = /(?:bytes=)?\d+-(\d+)$/;
  let fileIdef = 0;

  function parseEndpoint(endpoint) {
    if (/^(https?:)?\/\//.test(endpoint)) return endpoint;
    return endpoint.replace('/video-processor-secured/', '');
  }

  function parseRange(range) {
    const r = reRange.exec(range);
    return r ? parseInt(r[1], 10) + 1 : 0;
  }

  export default {
    name: 'irwUploadMeta',
    data() {
      const metas = [
        {
          id: 1,
          name: 'Users',
          type: 'METADATA_USERS',
        },
        {
          id: 2,
          name: 'Timing',
          type: 'METADATA_TIMING',
        },
      ];
      return {
        metas,
        files: metas.reduce((acc, meta) => {
          acc[meta.id] = [];
          return acc;
        }, {}),
        uploading: false,
        multiple: true,
        loading: false,
      };
    },
    computed: {
      canUpload() {
        return Object.values(this.files).some((meta) => meta.some((file) => (file.__checksum || file.__progress_checksum > 0) && !file.__doneUploading));
      },
    },
    methods: {
      humanStorageSize,
      initFiles() {
        this.files = this.metas.reduce((acc, meta) => {
          acc[meta.id] = [];
          return acc;
        }, {});
      },
      fileCanAdd(metaId) {
        return !this.uploading && this.files[metaId] && (this.multiple || this.files[metaId].length === 0);
      },
      filesUploaded(metaId) {
        return !this.uploading && this.files[metaId] && this.files[metaId].length > 0
          && this.files[metaId].every((f) => f.__doneUploading);
      },
      filePick(metaId) {
        if (this.fileCanAdd(metaId) && (this.$q.platform.is.mozilla || this.$q.platform.is.ie)) {
          this.$refs[`file_${ metaId }`][0].click();
        }
      },
      fileAdd(e, metaId) {
        if (!this.fileCanAdd(metaId)) {
          return;
        }

        let files = Array.prototype.slice.call(e.target.files);
        this.$refs[`file_${ metaId }`][0].value = '';

        files = files
          .filter((file) => !this.files[metaId].some((f) => file.name === f.name && file.size === f.size))
          .map((file) => this.fileInit(file, metaId));
        this.$set(this.files, metaId, this.files[metaId].concat(files));
      },
      fileRemove(file, metaId) {
        const id = file.__id;
        const done = file.__doneUploading;
        if (!done) {
          if (file.__cancelToken) {
            file.__cancelToken.cancel();
          }
          if (file.__checksum) {
            const payload = JSON.stringify({
              id: file.__checksum,
              name: file.name,
            });
            this.$http
              .post('/upload', payload, {
                params: {
                  uploadType: 'resumable',
                },
                headers: {
                  'X-Upload-Content-Type': file.type || 'application/octet-stream',
                  'X-Upload-Content-Length': file.size,
                  'Content-Type': 'application/json; charset=UTF-8',
                },
                noRetry: true,
              })
              .then((response) => this.$http.delete(parseEndpoint(response.headers.location)))
              .catch(() => {});
          }
        }
        file.__removed = true;
        this.$set(this.files, metaId, this.files[metaId].filter((obj) => obj.__id !== id));
      },
      fileInit(file, metaId) {
        fileIdef += 1;
        file.__id = fileIdef;
        file.__checksum = null;
        file.__size = humanStorageSize(file.size);
        file.__doneUploading = false;
        file.__failed = false;
        file.__failedStatus = null;
        file.__uploaded = 0;
        file.__progress = 0;
        file.__progress_checksum = 0;
        file.__promise_checksum = this
          .fileChecksum(file, metaId)
          .then((checksum) => {
            file.__checksum = checksum;
            this.$set(this.files, metaId, [...this.files[metaId]]);
            return checksum;
          })
          .catch(() => {
            file.__progress_checksum = 0;
          });
        return file;
      },
      fileChecksum(file, metaId) {
        return new Promise((resolve, reject) => {
          const blobSlice = File.prototype.slice || File.prototype.mozSlice || File.prototype.webkitSlice;
          const chunks = Math.ceil(file.size / chunkSize);
          const fileReader = new FileReader();
          const crypto = new asmCrypto.SHA256();
          let currentChunk = 0;

          function loadNext() {
            const start = currentChunk * chunkSize;
            const end = ((start + chunkSize) >= file.size) ? file.size : start + chunkSize;
            fileReader.readAsArrayBuffer(blobSlice.call(file, start, end));
          }

          crypto.process([file.name, file.size].join('#'));

          fileReader.onload = (e) => {
            if (file.__removed) {
              reject();
            } else {
              try {
                crypto.process(e.target.result);
                if (currentChunk < chunkMaxCount || currentChunk > chunks - chunkMaxCount - 1) {
                  currentChunk += 1;
                } else {
                  currentChunk = chunks - chunkMaxCount;
                }
                file.__progress_checksum = (currentChunk * 100) / chunks;
                this.$set(this.files, metaId, [...this.files[metaId]]);
                if (currentChunk < chunks) {
                  loadNext();
                } else {
                  resolve(asmCrypto.bytes_to_hex(crypto.finish().result));
                }
              } catch (err) {
                reject(err);
              }
            }
          };

          fileReader.onerror = (err) => {
            reject(err);
          };

          loadNext();
        });
      },
      startUpload() {
        this.uploading = true;
        let q = Promise.resolve();
        Object.keys(this.files).forEach((metaId) => {
          const metaIdInt = parseInt(metaId, 10);
          const meta = this.metas.find((s) => s.id === metaIdInt);
          this.files[metaId].forEach((file) => {
            file.__failed = false;
            file.__failedStatus = null;
          });
          q = q.then(() => this.processUpload(meta)).catch(() => true);
        });
        return q.then(() => {
          this.uploading = false;
          return this.$http
            .post('/users/eventWrite', stringify({
              location_id: parseInt(this.$route.params.idLocation, 10),
              status: 'METADATA_UPLOAD_FINISHED',
            }, { arrayFormat: 'brackets' }), {
              headers: {
                'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8',
              },
            })
            .catch((rejection) => rejection);
        });
      },
      processUpload(meta) {
        const metaId = String(meta.id);
        const files = this.files[metaId]
          .filter((file) => !file.__failed && !file.__removed && !file.__doneUploading && file.__progress_checksum > 0)
          .sort((a, b) => (a.size * (2 - (a.__progress_checksum / 100))) - (b.size * (2 - (b.__progress_checksum / 100))));
        if (!files.length || !this.uploading) {
          return Promise.resolve();
        }
        const file = files[0];
        file.__cancelToken = CancelToken.source();
        const uploadPromise = () => new Promise((resolve, reject) => {
          if (!this.uploading || file.__removed || !file.__checksum) {
            return reject(new Error());
          }
          const uploadLength = file.size;
          let uploadOffset = 0;
          let endpoint = '/upload';
          const upload = (fileId) => {
            if (uploadOffset >= uploadLength) {
              return resolve({ fileId });
            }
            const blob = file.slice(uploadOffset, uploadOffset + chunkSize);
            return this.$http
              .put(endpoint, blob, {
                cancelToken: file.__cancelToken.token,
                headers: {
                  'Content-Type': file.type || 'application/octet-stream',
                  'Content-Range': `bytes ${ uploadOffset }-${ (uploadOffset + blob.size) - 1 }/${ uploadLength }`,
                },
                noRetry: true,
                onUploadProgress: (progressEvent) => {
                  file.__uploaded = Math.min(uploadLength, uploadOffset + progressEvent.loaded);
                  file.__progress = Math.min(100, (file.__uploaded * 100) / uploadLength);
                  this.$set(this.files, metaId, [...this.files[metaId]]);
                  return progressEvent;
                },
              })
              .then((response) => {
                if (response.status === 201) {
                  return resolve({ fileId });
                }
                uploadOffset = parseRange(response.headers.range);
                return upload(response.data ? response.data.fileId : null);
              })
              .catch((rejection) => {
                if (!isCancel(rejection)) {
                  reject(new Error('Invalid Upload-Offset'));
                }
                return reject(rejection);
              });
          };
          const payload = JSON.stringify({
            id: file.__checksum,
            name: file.name,
            meta: {
              location_id: parseInt(this.$route.params.idLocation, 10),
              meta_type: meta.name,
            },
          });
          return this.$http
            .post(endpoint, payload, {
              cancelToken: file.__cancelToken.token,
              params: {
                uploadType: 'resumable',
              },
              headers: {
                'X-Upload-Content-Type': file.type || 'application/octet-stream',
                'X-Upload-Content-Length': file.size,
                'Content-Type': 'application/json; charset=UTF-8',
              },
              noRetry: true,
            })
            .then((response) => {
              endpoint = parseEndpoint(response.headers.location);
              return endpoint;
            })
            .catch((rejection) => {
              if (rejection.response && rejection.response.status === 409) {
                endpoint = parseEndpoint(rejection.response.headers.location);
                return endpoint;
              }
              return Promise.reject(rejection);
            })
            .then(() => this.$http
              .put(endpoint, null, {
                cancelToken: file.__cancelToken.token,
                headers: {
                  'Content-Range': `*/${ file.size }`,
                  'Content-Type': file.type || 'application/octet-stream',
                },
                noRetry: true,
              })
              .then((response) => {
                if (response.status === 206) {
                  uploadOffset = parseRange(response.headers.range);
                  file.__uploaded = uploadOffset;
                  file.__progress = Math.min(100, (file.__uploaded * 100) / uploadLength);
                  this.$set(this.files, metaId, [...this.files[metaId]]);
                  return upload();
                }
                file.__progress = 100;
                this.$set(this.files, metaId, [...this.files[metaId]]);
                return resolve(response);
              }))
            .catch(reject);
        });
        return file.__promise_checksum
          .then(uploadPromise)
          .then(() => {
            file.__doneUploading = true;
            return this.$http
              .post('/resource/create', stringify({
                file: [file.__checksum],
                file_name: [`${ file.__checksum }.${ file.name.split('.').slice(-1).join('').toLowerCase() }`],
                overwrite: false,
                use_id_as_name: true,
                use_name_as_id: false,
                mime_type: file.type,
                type: meta.type,
                storage_server_id: 1,
                stop_on_error: true,
                metadata: JSON.stringify({
                  location_id: parseInt(this.$route.params.idLocation, 10),
                  meta_type: meta.name,
                  file_name: file.name,
                  file_size: file.size,
                  file_type: file.type,
                  uploaded_timestamp: (new Date()).valueOf(),
                }),
              }, { arrayFormat: 'brackets' }), {
                headers: {
                  'Content-Type': 'application/x-www-form-urlencoded;charset=utf-8',
                },
              })
              .catch((rejection) => {
                const msg = getRejectionMessage(rejection, 'There was an error creating resource.');
                if (!isCancel(rejection) && msg.indexOf('Resource already exists') === -1) {
                  showRejectionMessage(rejection, 'There was an error creating resource.');
                }
                return rejection;
              });
          })
          .catch((error) => {
            if (error !== true) {
              file.__failed = true;
              if (typeof error === 'string') {
                file.__failedStatus = error;
              } else if (isCancel(error)) {
                file.__failedStatus = 'Upload cancelled';
              } else {
                file.__failedStatus = getRejectionMessage(error, 'Error uploading - try again');
              }
            }
            return error;
          })
          .then(() => {
            this.$set(this.files, metaId, [...this.files[metaId]]);
            return this.processUpload(meta);
          });
      },
      stopUpload() {
        this.uploading = false;
        Object.values(this.files).forEach((meta) => {
          meta.forEach((file) => {
            const done = file.__doneUploading;
            if (!done && file.__cancelToken) {
              file.__cancelToken.cancel();
            }
          });
        });
      },
      currentUploadStats(meta) {
        if (meta) {
          return meta.reduce((acc2, file) => {
            acc2.files += 1;
            acc2.total += file.size;
            acc2.uploaded += file.__uploaded;
            acc2.progress = (acc2.uploaded * 100) / acc2.total;
            return acc2;
          }, {
            files: 0,
            total: 0,
            uploaded: 0,
            progress: 0,
          });
        }
        return Object.values(this.files).reduce((acc1, m) => m.reduce((acc2, file) => {
          acc2.files += 1;
          acc2.total += file.size;
          acc2.uploaded += file.__uploaded;
          acc2.progress = (acc2.uploaded * 100) / acc2.total;
          return acc2;
        }, acc1), {
          files: 0,
          total: 0,
          uploaded: 0,
          progress: 0,
        });
      },
    },
    mounted() {
      this.initFiles();
    },
    beforeRouteUpdate(to, from, next) {
      this.initFiles();
      next();
    },
  };
</script>
